module dmd.TemplateExp;

import dmd.Expression;
import dmd.OutBuffer;
import dmd.Loc;
import dmd.HdrGenState;
import dmd.TemplateDeclaration;
import dmd.TOK;

class TemplateExp : Expression
{
	TemplateDeclaration td;

	this(Loc loc, TemplateDeclaration td)
	{
		super(loc, TOK.TOKtemplate, TemplateExp.sizeof);
		//printf("TemplateExp(): %s\n", td.toChars());
		this.td = td;
	}

	void rvalue()
	{
		error("template %s has no value", toChars());
	}

	void toCBuffer(OutBuffer buf, HdrGenState* hgs)
	{
		buf.writestring(td.toChars());
	}
}

